Ud -0d0 #3438

hrpsys-base O rtm.py:reeadDataPort() O O O O disconnect) D OO OO O
2016/01/29 04:53 - n-ando

googdod: og ggdog: 2016/01/29
goo: od goo:

ggdod: ggdog: 90%
good: good: 0.00C O
googooo:

oo

https://github.com/fkanehiro/hrpsys-base/issues/905

gooooooobonb

00000 2719 -2016/05/13 10:14 - n-ando

Now data value is stored to PortProfile.properties. refs #3438

00000 2719 -2016/05/13 10:14 - n-ando

Now data value is stored to PortProfile.properties. refs #3438

oo

#1 -2016/01/29 04:54 - n-ando

10 0 OutPortCorbaCdrProvidercpp 0 0 00000000000 OOOOOO
logger 00O OOOOO

#2 - 2016/01/29 09:40 - n-ando
-00oo0oo0O0 1000

00 00000OOutPortCorbaCdrProvider 0 DO DO DOO0O0OO0OODOOO

(gdb)O where

#00 O do_lookup_x0O (new_hash=new_hash@entry=1732989254,00 old_hash=old_hash@entry=0x7ffff26af0c0,(]
0 0 O O result=result@entry=0x7ffff26af0d0,0] scope=<optimizedd out>,00 i=i@entry=0,0 flags=flags@entry=5,00
0 0 O O skip=skip@entry=0x0,00 undef_map=undef_map@entry=0x7ffff7ff7a08)0 atll dl-lookup.c:228

#10 0 0x00007ffff7de49910 in0 _dI_lookup_symbol_x (

0 0 0O O undef_name=0x7ffff6fd34700 "_ZN7omniORB6loggerC1EPKc",00 undef_map=0x7ffff7ff7a08,0

00 0O O ref=ref@entry=0x7ffff26af188,[1 symbol_scope=0x7{fff7ff7d60,0] version=0x0,]

0 0 0O O type_class=type_class@entry=1,00 flags=5,00 skip_map=skip_map@entry=0x0) at( dI-lookup.c:737

#20 0 0x00007ffff7de95570 in0 _dI_fixupO (I=<optimizedd out>,0 reloc_arg=<optimizedOd out>)

0000 atO ./elf/dl-runtime.c:111

#30 0 0x00007ffff7df05150 in0 _dI_runtime_resolved ()O at0 ../sysdeps/x86_64/dl-trampoline.S:45

#4[0 0 0x00007ffff7087f3al ind omniServant:“omniServant()d ()O fromO /usr/lib/libomniORB4.so0.1

#50 0 0x00007ffff7a6e5bdl] in(J RTC::OutPortCorbaCdrProvider::"OutPortCorbaCdrProvider (

0 0 O O this=0x7fffe0006050,0 __in_chrg=<optimized[ out>,0] _ vtt_parm=<optimized out>)

0 0 0O O atd OutPortCorbaCdrProvider.cpp:68

#60 [ 0x00007ffff7a6eab80 in(] RTC::OutPortCorbaCdrProvider:”OutPortCorbaCdrProvider( (

0 0 O O this=0x7fffe0006050,0 __in_chrg=<optimized[ out>,0] _ vtt_parm=<optimized] out>)

00 0O O atd OutPortCorbaCdrProvider.cpp:100

#70 O 0x00007ffff7a6f9520 in coil::Destructor<RTC::OutPortProvider,[J RTC::OutPortCorbaCdrProvider>0 (
00 0O O obj=@0x7fffe000bd18:(] 0x7fffe0006050)0 atll ../../../src/lib/coil/include/coil/Factory.h:80

#80 O 0x00007ffff7a2b8010 in[ coil::Factory<RTC::OutPortProvider,[ std::string,0 std::less<std::string>,0 RTC::OutPortProvider*[ (*)(),0 voidO (*)(RTC::Out
tProvider*&)>::deleteObject (this=0x69d100,]

00 0O O obj=@0x7fffe000bd18:0] Ox7fffe0006050)0 atl ../../../src/lib/coil/include/coil/Factory.h:343

#90 O 0x00007ffff7a2b3190 in0 RTC::OutPortPullConnector::disconnectd (this=0x7fffe000b8d0)

0 0 0O O atd OutPortPullConnector.cpp:99

#100 0x00007ffff7a2b18f0] in( RTC::OutPortPullConnector::"OutPortPullConnector(] (this=0x7fffe000b8d0,[]
0000 __in_chrg=<optimizedd out>)d atd OutPortPullConnector.cpp:68

#1100 0x00007ffff7a2blect in( RTC::OutPortPullConnector:~OutPortPullConnector( (this=0x7fffe000b8d0,]
0000 __in_chrg=<optimizedd out>)0 atC] OutPortPullConnector.cpp:69

#1200 0x00007ffff7a4feec inO RTC::OutPortBase::unsubscribelnterfacesd (this=0x6a7b20,00

0 0 O O connector_profile=...)0 at(] OutPortBase.cpp:691

#1300 0x00007ffff7a5ad12[] in(] RTC::PortBase::notify_disconnectl] (this=0x6a7b20,0]

0 0 O O connector_id=0x7fffd4000b100 "4446e7af-045d-43d6-a451-8a9178b987c3")0 atl] PortBase.cpp:422
#1400 0x00007ffff7a8e7370 inl _ORL_Icfn_bf82f9885dac07a6_b4000000(omniCallDescriptor*,.] omniServant*) ()
0 0 O fromO /home/n-ando/tmp/OpenRTM-aist-1.1.1/src/lib/rtm/ libs/libRTC-1.1.1.s0

#1500 0x00007ffff7092ae30 in omni::omniOrbPOA:dispatch(omniCallDescriptor&,[] omniLocalldentity*) ()

0 0 O from0O /usr/lib/libomniORB4.s0.1

#1600 0x00007ffff7077de60 in(l omniLocalldentity::dispatch(omniCallDescriptor&)O ()

0 0 O fromO /usr/lib/libomniORB4.s0.1

#1700 0x00007ffff70868d501 in(J omniObjRef::_invoke(omniCallDescriptor&, bool)[ ()

0 0 O fromO /usr/lib/libomniORB4.s0.1

#1800 0x00007ffff7a9de790 in(l RTC::_objref_PortService::notify_disconnect(char const*)O ()

00 0O fromd /home/n-ando/tmp/OpenRTM-aist-1.1.1/src/lib/rtm/.libs/libRTC-1.1.1.50

#1900 0x00007ffff7a5a6ael] in RTC::PortBase::disconnectl] (this=0x6a7b20,0]

0 O O O connector_id=0x7fffd4000b100 "4446e7af-045d-43d6-a451-8a9178b987¢c3")J at[] PortBase.cpp:368
#200 0x00007ffff7a8e6a70 in(0 _ORL_Icfn_bf82f9885dac07a6_84000000(omniCallDescriptor*,[1 omniServant*)O ()
0 0 O fromO /home/n-ando/tmp/OpenRTM-aist-1.1.1/src/lib/rtm/ libs/libRTC-1.1.1.s0

#2100 0x00007ffff70a13610 in omniCallHandle::upcall(omniServant*,(0 omniCallDescriptor&) ()

0 0 O from0O /usr/lib/libomniORB4.s0.1

gooooooooooo

(gdb)0 info thread

OO0dOCOCOTargetO IdOOOOOODOO O Framed

*0 160 O O ThreadO Ox7ffff26b07000 (LWPO 17597)0 "It-SeqOutComp"0 do_lookup_xO (

0 0 O O new_hash=new_hash@entry=1732989254,[1 old_hash=old_hash@entry=0x7ffff26af0c0,l]

0 0 O O result=result@entry=0x7ffff26af0d0,[] scope=<optimized out>,0] i=i@entry=0,00 flags=flags@entry=5,00

0 0 0O O skip=skip@entry=0x0,00 undef_map=undef_map@entry=0x7ffff7ff7a08)0 atO dl-lookup.c:228

0070000 ThreadO Ox7ffff2eb17000 (LWPL 24415)0 "lt-SeqOutComp" 0x00007ffff7093e6el] inL) omni::omniOrbPOA:lastinvocationHasCompleted(o
alldentity*)00 ()O fromO /usr/lib/libomniORB4.so0.1

0060000 Threadd Ox7ffff36b27000 (LWPLO 24395)0 "It-SeqOutComp"d 0x00007ffff73637eb in0 __libc_recvd (fd=12,0
0 0 O O buf=0x7fffdc000a98,0] n=8192,00 flags=-1)01 atd ../sysdeps/unix/sysv/linux/x86_64/recv.c:33

0050000 Thread Ox7ffff3eb37000 (LWPL 24391)0 "It-SeqOutComp"] 0x00007ffff6092f3d inl nanosleep ()

000 O atO ../sysdeps/unix/syscall-template.S:81

004000 0O ThreadO 0x7ffff48c07000 (LWPO 24385)0 "lt-SeqOutComp"[ pthread_cond_timedwait@@GLIBC_2.3.2[1 ()

00 0 O atO ../nptl/sysdeps/unix/sysv/linux/x86_64/pthread_cond_timedwait.S:238

0030000 Thread Ox7ffff50c17000 (LWPO 24384)01 "It-SeqOutComp" 0x00007ffff60bf12d inO polld ()

0 0 0 O atO ../sysdeps/unix/syscall-template.S:81

0020000 ThreadO Ox7ffff58c27000 (LWPLO 24383)0 "It-SeqOutComp"[] 0x00007ffff60c3da30] in0l select ()

000 O atO ../sysdeps/unix/syscall-template.S:81

001000 0 ThreadO Ox7ffff7fc97c00 (LWPL 24379)0 "It-SeqOutComp"0 pthread_cond_wait@@GLIBC_2.3.20 ()

000 O atO ../nptl/sysdeps/unix/sysv/linux/x86_64/pthread_cond_wait.S:185

#3-2016/01/29 10:08 - n-ando
-000 0100020000

omniORBO OO 0OOOOOOOOOOODOOODOOODODOODODODODODODODDDODODDODOD

“OutPortCorbaCdrProvider(void)

PortableServer::Objectld_var{ oid;

oidd =0 _default_POA()->servant_to_id(this);

_default_POA()->deactivate_object(oid);

>>[1 omniORB:[ State[] root<2133>[ (active)] ->[ deactivating

>>[1 omniORB:0 Objectd isO stilld busyd --0 etherealisel later.0d <-O deactivate 0 0 0 000000000 OOO
oooooooooo

>>[1 omniORB:[ ObjRef(IDL:OpenRTM/OutPortCdr:1.0)0 --[] deleted.

>>[] omniORB:00 ERRORD --0 A servant[] hasO been( deletedO that[ isC still activated.

>>0 00 0000id:0 root<2133>0 (deactivating)

>>[1 omniORB: sendChunk:[] tod giop:tcp:[::ffff:10.211.55.4]:395030] 28[] bytes

>>[] omniORB:0O

>>[1 47490 4f500 01020 01011 100001 00000 b6610 00000 GIOP...... a.
>>[1 00001 0000 0000 0000 boooT oOCO OO DOOODOOD ..

>>[1 omniORB: POA(RootPOA) etherealisingd object root<2133>0 (deactivating).
>>0 0id:0

>>[] omniORB:[J Assertion[] failed.OJ 0 This( indicates] all bugll in(] thed application
>>[1 usingd omniORB,O ord maybe in( omniORBO itself.

>>0 O file:O ./../../../../src/lib/omniORB/orbcore/omniServant.cc

>>0 0 line:d 223

>>[1] 0 info:0 activation_found

>>[] omniORB:00 WARNINGO --0 methodO ‘get' raisedd anJ unexpected

>>[] exceptiond (notl all CORBAL exception).

goooooooooooooo

omniORB:0 giopWorker( task[] execute.

omniORB:[ inputMessage:[J from( giop:tcp:[::ffff:10.211.55.4]:395030 1050 bytes
omniORB:[

47490 4f500 01020 01000 5d000 00000 b66101 00000 GIOP....]....a..
03000 00000 00001 0000 0e00O 00000 fedfl b7aall ..............

56000 003el] 70000 00000 000201 9000 ObOOO 00000 V..>p...........

64690 73630 6f6el] 6e650 63740 00001 0000 00000 disconnect......
25000 000001 62640 64610 33360 356601 2d340 393901 %...bdda365f-499
622d0 34650 333601 2d62[1 34370 342d 313901 333001 b-4e36-b474-1930
3239035630 6131034310000 00000000000 ODOODOOO295¢ca141.
1

2

3

4

omniORB:[ State[d root<2133>[ (active) ->[] deactivating

omniORB:0 ObjectO isO stilld busyd --[1 etherealise later.

5

omniORB:[0 ObjRef(IDL:OpenRTM/OutPortCdr:1.0)0 --O deleted.

omniORB:00 ERRORO --00 A servantd has been deletedO that isO still0 activated.
000 000id:0 root<2133>0 (deactivating)

omniORB:[0 sendChunk:[ toll giop:tcp:[::ffff:10.211.55.4]:395030 280 bytes
omniORB:0

47490 4f500 010200 01010 100001 00000 b66101 0000 GIOP......... a.

00001 00001 0000 0000 VOO OO O OO OOOOODO e
omniORB:0 POA(RootPOA)[ etherealising[] object[] root<2133>0 (deactivating).
Oid:0

omniORB:0 Assertion(] failed.OJ [0 ThisO indicatesO all bugd in( the application
usingd omniORB,0 ord maybe in(0 omniORBO itself.

Ofile:d ../../../../../src/lib/omniORB/orbcore/omniServant.cc

O line:0 223

0 info:0 activation_found

omniORB:[0 WARNINGO --00 method[ 'get'0 raised(] an[] unexpected

O exceptiond (not ald CORBAL exception).

omniORB:0 sendChunk:[ tod giop:tcp:[::ffff:10.211.55.4]:395030 680 bytes
omniORB:[J

47490 4f5000 01020 0101 380001 00000 b461 0000 GIOP....8...a..

02000 00000 00001 0000 1e000 00000 49440 4c3al ........... IDL:

6f6d0 672el] 6f720 672f0 434f0 52420 412f0] 554e] omg.org/CORBA/UN
4b4e(] 4570 4e3all 312e[] 300001 393900 01000 4d4f0 KNOWN:1.0.99..MO
oioofoooOl OO0 OOOODODOOODOOODODOOOODODOODDOOOOD..
omniORB:[ inputMessage:[J from0O giop:tcp:[::ffff:10.211.55.4]:395030 720 bytes
omniORB:[O

47490 4f500 01020 01000 3c000 00001 b8610 0000 GIOP....<....a..

03000 00000 00001 0000 0e00O 00000 fedfld b7aall ..............

560001 003el] 700000 00001 0003 d900O 11000 00000 V..>p.........

67650 745f0 706f0 72740 5f700 726f0 66690 6c¢650 get_port_profile
00000 o00OOT 0o0OT oOOO D DO OO DDOODDOOOODOOODO....
omniORB:[0 SocketCollection idle.r] Sleeping.

omniORB:0 inputMessage:[ from giop:tcp:[::ffff:10.211.55.3]:313800 1100 bytes
omniORB:[J

47490 4f5000 01021 0000 00001 00621 0000LCI 03110 GIOP......b....

03000 00000 00001 00001 00000 000el fedfll b7aall ..............

56000 003el] 70000 0000 0O00LI OO0 0000O 000eld V..>p..........

5f6el] 6f6el] 5f6501 786901 73740 656e] 740001 0000 _non_existent...
00000 00030 000001 000100 00000 000cl 0000 00000 ...

00010 00010 000101 010901 00000 0011 00000 00020 ................

00020 00000 4e450 4f000J 000001 00020 0014000 0O 0O O ...NEO......

#4 - 2016/01/29 10:11 - n-ando
-000 02000 30000

omniORB: Object is still busy -- etherealise later.J 0 0000000000000 O0OOO
goooooooo

deactivate_object) 0O O 0O _remove ref) OO OODOOOOO

"Objectl isO stilld busyO --0 etherealisel later."O)
Thel POALD is0d still0 usingd) oneld of(] your[ servants...

"ERRORO --00 A servant has been( deletedd that( is stillC) activated."O
But yould seem0 to[] havell deleted it!!

ThisO soundsO liked your( servantO lifecycled design isJ incorrect.0 Thel POA

mustO bel finishedO with an0 active servantd beforel it0 canO bel deleted.O 1t0 is

very hard( tod knowd when{ thed POAL isO finishedO with a0l servantO -0 youl canO call
“deactivate_object()'T -0 butd thed POAO can0 stillC keepd hold of0 the servant

forQ anO arbitary timel (untilO ongoingU callsC) arel] complete).0] Henningd &

VinoskiO sectiond 11.901 (pp499-502)0 isO the[ bestO referencel 10 knowd onO this.
Solutions:
1.0 RefCountServantBase

Thed approach0 100 alwaysO use is[] tod usel the[d mix-in0 class
“RefCountServantBase'.J This implementsO alJ simplel referencel] counting
mechanism.[ RefCountServantBase::_remove_ref()[] deletes] the[] object[] when
theO refld countO fallsO tod zero.O The POAD isO refcount-aware,[d sol it0 calls
_add_ref()0 &0 _remove_ref()d as0 required.

When[ youl are( finishedd with( all servantO youl need( to dod] twol thingsO (in
eitherO order):

0 *0 calld deactivate_object()d in0 the object's0 POA.O See[ thisO filed for( an
0 O O exampled ofd codel tol calld deactivate_object()d for( you:

http://cvs.sf.net/viewcvs.py/omniifr/omniifr/repository/IRObject.cc?rev=1.1&view=auto
0*0 calld _remove_ref()d tod releasel] your own[ referencel] to] the[ servant.

00 0O (TheOd newlyO contructed object[ always[ hasC al refd count of] '1'.)0 You
0 0 O canO doO thisO as0 soond as] thell obectd isO activated,[ if0) you[l don'td) want
0 0 0O tod refer0 tol thel servant exceptd though the[d POA.

2.0 POAL deactivate

Your problem seemsO to] occurd when[J youll are deactivatingd all POA,[] or[ perhaps

shuttingd downO the ORB.

1f0 you makel surel that[] thed POAQD isC] completely[l deactivated] BEFORE[] you
delete[] anyO servantO objects,0 thenO youl should( be[ safe.0) Calld POA:[ (or
ORB::)[ deactivate()OJ with( the “wait_for_completion'(] parameter( set(] to

TRUE.O Onlyd thend shouldd youO delete your( servant[] objects.

3.0 Servant Activator
Youl canl installC) al servantO activator in0 your POA.O The POAQ willO thenO call
incarnate()0 when( it0) wantsO alJ new( servant,[] and[] etherealize()d when( the

servant[] can] bel] deleted.

SeelJ OmniEvents::ProxyPullSupplierManager for(] an] examplel of( this
approach.

Letd meO know how youll get[] on.

-Alex

#5 - 2016/01/29 10:37 - n-ando

_remove_ref) 00 0000000000000 OO0OO0OOOOOOOOOOOOOO
oidd =00 _default_POA()->servant_to_id(this);

>>[] omniORB:0 Addingd root<14974>0 (activating)d tol objectd table.
>>[] omniORB:[J Statel] root<14974>[] (activating) ->[] active

>>[1 omniORB:0 Application check failed.OJ ThisO indicates™ all bugd in0 theO application
>>[] 0 usingd omniORB.0O O Seel the commentO in0 the[ source codel ford morel info.

>>[ 0 file:0 ../../../../../src/lib/omniORB/orbcore/portableserver.cc

>>[0 0 line:d 273

>>[ 0 info:0 _pd_refCount >0 0

_default_POA()->deactivate_object(oid);

this->_remove_ref();

>>[] omniORB:[ State[] root<14974>0] (active)O ->[ deactivating

>>[1 omniORB:[0 POA(RootPOA)LI etherealising] object root<14974>0 (deactivating).
>>[1id:0 IDL:OpenRTM/OutPortCdr:1.0

>>[] omniORB:[ State[] root<14974>[] (deactivating)d ->[ etherealising

>>[1 omniORB:J Removing[ root<14974>[1 (etherealising)] from[ object] table
>>[1 omniORB:[J Object table[] entry root<14974>[ (dead)] deleted.

>>[] omniORB:[ ServantBasell hasO zerod refl] countl --0 deleted.

portableserver.cc 12730 0000000

http://sourceforge.net/p/omniorb/svn/HEAD/tree/tags/4_1_6/omniORB/src/lib/omniORB/orbcore/portableserver.cc#1273

void
PortableServer::ServantBase::_add_ref()
{

0 0O omni_tracedmutex_lock I(ref_count_lock);

00 //0 If0 theO referencel count is0 0,00 thenO the[ object isO eitherd in0 the
0 O //0 processd of 0 beingl deletedd by _remove_ref,0 or() hasO already been
0 0 //0 deleted.O 1t0 isO tool late to bel trying( tol _add_ref(] now.O IfO the
00 //0 referencel countO isO lessO than zero,0 then[ _remove_ref(] hasO been
0 0 //0 calledd too[l manyO times.

0 O OMNIORB_USER_CHECK(_pd_refCount >[1 0);

0 O _pd_refCount++;

}

void
PortableServer::ServantBase:;_remove_ref()
{

0 O ref_count_lock.lock();

0 O intd doneld =0 --_pd_refCountd > 0;
0 O ref_count_lock.unlock();

0 0Oif(d0 doned )O O return;

0 0if(0 _pd_refCountd < 00 )OO {

00 0O O omniORB:logs(1,0 "ServantBase[l has negativel ref(] count!");
0000 return;

oo}

0 O omniORB::logs(15,0 "ServantBased has zero[ refd countd --0J deleted.");

O00tryO {

0 0 0O O delete this;
oo}

0 0O catchO (...)O {

0 0 O O omniORB:logs(1,0 "ERROR:O Servantd destructord threw anJ exception.");

oo}
}

gobO04200000000000000000£O

void
PortableServer::ServantBase::_add_ref()

{

0 O _pd_refCount.inc();

}

void
PortableServer::ServantBase:;_remove_ref()

{
0 0Oint0O valO =0 _pd_refCount.dec();

0 Oifd (vald >0 0)
0000 return;

0 Oifd (vald <O 0)O {

00 0O O omniORB:logs(1,0 "ServantBase[l has negativel ref(] count!");
0000 return;

oo}

0 O omniORB::logs(15,0 "ServantBased has zero[ refd countd --0J deleted.");

O00tryO {

000 O deleted this;

oo}

0 0O catchO (...)O {

0 0O O O omniORB:logs(1,0 "Error:0 Servantd destructord threw an(J exception.");
oo}

}

#6 - 2016/01/29 10:43 - n-ando
4160 _add_ref) 00O _pd refCount0000000000O0O0OOO

4200000 _pd_refCount.inc(), _pd_refCountdec) DO 0000000000 OOOOOOO omnithread/atomic.h
000000000LInuxOO gecO __sync add and fetch 00000000000 000000000

class _OMNITHREAD_NTDLL_[J omni_refcountO {
public:

0 O inlined omni_refcount(intd start)[] :0 count(start)O {}
0 O inlined “omni_refcount()O {}
0 0 //0 AtomicallyOd incrementO referencel] countd and( return] newl value
O Oinlined int0 inc()O {

0000 returnd __sync_add_and_fetch(&count,[] 1);

oo}

0 0 //0 Atomicallyd decrement(] referenced countd and[ return new[ value
0 O inlined int0 dec()O {

000 O returnd __sync_sub_and_fetch(&count,( 1);

oo}

0 0O //0 Return snapshot(] of 0 currentd value.OJ RealO) count may[] havell changed by
00 //0 thed timeO thed valueO isCI looked at!

0 O inlined intO value()O {

00O 00O returnd count;

oo}

private:
0 O volatiled int0 count;

b
00000WindowsO OO

class] _OMNITHREAD_NTDLL_[ omni_refcountO {
public:

0 O inlined omni_refcount(int0 start)d :0 count(start)Od {}
0 O inlined “omni_refcount()O {}

0 0 //0 Atomicallyd incrementO referencel] countd and( returnC] new[ value
O O inlined int0 inc()O {

00 0O O returnd InterlockedIncrement(&count);

oo}

0 0 //0 Atomicallyd decrement[] referenced countd and[ return new( value
0O O inlined int0 dec()O {

00 0O O returnd InterlockedDecrement(&count);

oo}

0 0O //0 Return snapshot( of 0 currentd value.OJ RealO) count may[] havell changed by
00 //0 thed timeO thed value isCI looked( at!

0O O inlined intO value()O {

00O 00O returnd count;

oo}

private:
0 O volatiledd LONGO count;

b

O00gecO VCOOOO

#7 -2016/01/29 12:19 - n-ando
O0O0OomniORB-420 000000000000

n-ando@ubuntul404:~/tmp/test42/RELENG_1_1/0penRTM-aist/examples/SeqlO$0] exportd LD_LIBRARY_PATH=/usr/local/lib
n-ando@ubuntul404.”/tmp/test42/RELENG_1_1/0OpenRTM-aist/examples/SeqlO$0 IddO .libs/1t-SeqOutComp

00000000 linux-vdso.so.10 =>[0 O (0x00007fff07ff8000)

00000000IbRTC-1.1.2.s000 => /home/n-ando/tmp/test42/RELENG_1_1/0OpenRTM-aist/src/lib/rtm/.libs/libRTC-1.1.2.s0] (0x00007f32chfee000)
00000000 libeoil-1.1.2.s000 =>0 /home/n-ando/tmp/test42/RELENG_1_1/0OpenRTM-aist/src/lib/coil/lib/.libs/libcoil-1.1.2.s000 (0x00007f32cbdd6000
00000000 libpthread.so.00 =>0 /1ib/x86_64-linux-gnu/libpthread.so.00J (0x00007f32cbb91000)

00000000 libomniORB4.so.200 =>0 /usr/local/lib/libomniORB4.s0.2[0 (0x00007f32cb7¢8000)

00000000 libomnithread.so.400 =>0 /usr/local/lib/libomnithread.so.400 (0x00007f32cb5¢1000)

00000004 libomniDynamic4.so.20 =>0 /usr/local/lib/libomniDynamic4.s0.20 (0x00007f32cb0a4000)

00000000 libstde++.s0.60 =>0 /usr/lib/x86_64-linux-gnu/libstdc++.s0.60 (0x00007f32cada0000)

00000000 libgee_s.s0.10 =>0 /lib/x86_64-linux-gnu/libgcc_s.s0.100 (0x00007f32cab89000)

00000000 libeso.60 =>0 /1ib/x86_64-linux-gnu/libc.so.600 (0x00007f32ca7c4000)

00000000 libuuid.so.10 =>0 /lib/x86_64-linux-gnu/libuuid.so.10 (0x00007f32ca5bf000)

00000000 libdlso.20 =>0 /1lib/x86_64-linux-gnu/libdl.so.200 (0x00007f32ca3ba000)

000000004 libmso.60=>0/lib/x86_64-linux-gnu/libm.so.6[] (0x00007f32ca0b4000)

00000000 /1ib64/1d-linux-x86-64.s50.20 (0x00007f32cc518000)

4200 /usr/local OO0 OO0O0OOOOO0OOOOORELENG_ 1_1000042000000000
000000 omniORB: Object is still busy -- etherealise later. 0 0 00 O

1
2

3

4

omniORB:[ Statel] root<6458>[1 (active) ->[] deactivating

omniORB:[0 Object[ isO stilld busy[ --0 etherealise[] later.

5

omniORB:[0 ObjRef(IDL:OpenRTM/OutPortCdr:1.0)0 --O deleted.

omniORB:[ Error:0 all servant[ hasCl been deleted( that[l isO stillC) activated.
000000i0d:0 root<6458>[1 (deactivating)

omniORB:[0 ObjRef(IDL:omg.org/RTC/PortService:1.0)0 --0 deleted.

omniORB:[0 sendChunk:[ toll giop:tcp:[::ffff:10.211.55.4]:472810 280 bytes
omniORB:0

47490 4f500 010200 01010 100001 00000 78280 0100C1 GIOP.......X(..

00000 00000 00001 0000 co0CT 0OOOU DD DL OOUT DD e
omniORB:0 POA(RootPOA)[ etherealising[] object[] root<6458>[ (deactivating).
Oid:0

omniORB:0 Assertion(] failed.OJ [0 ThisO indicatesO all bugd in( the application
usingd omniORB,0 ord maybe in(0 omniORBO itself.

O file:d omniServant.cc

Oline:0 168

0 info:0 activation_found

omniORB:[0 Warning:O method( ‘get'0 raisedd anC) unexpectedd exceptiond (notd alJ CORBAL exception).
omniORB:[0 sendChunk:[ toll giop:tcp:[::ffff:10.211.55.4]:472810 680 bytes
omniORB:0

00 00 “OutPortCorbaCdrProvider() 0 _remove_ref) OO0 O0OO0O0OOOreadDataPort 0 0 000000000

omniORB:[ State[d root<14975>0 (active) ->[ deactivating

omniORB:00 POA(RootPOA)[ etherealising[] object[] root<14975>[] (deactivating).
0 id:0 IDL:OpenRTM/OutPortCdr:1.0

omniORB:[ Statel] root<14975>[1 (deactivating)[] ->[J etherealising

omniORB:0 Removingd root<14975>[1 (etherealising)] fromO object( table
omniORB:[ Object( table[ entryd root<14975>[] (dead)[ deleted.

omniORB:0 ServantBaseO hasO zeroO refl] countO --01 deleted.

1

2

3

Program received signald SIGSEGV,U SegmentationU fault.

[SwitchingO to Thread Ox7fffee7fc7000 (LWPO 4124)]

0x00007ffff612d65al in __Gl__10_default_xsputnd (f=0x7fffedffd600,00 data=0x7ffff7221ef7,00 n=0)
000 0O atd genops.c:447

4470 000genopsc0000000DOODOODODOODOODOOODOOO.

bt 0000000 _remove_ref) 000 0O0O0OO0OOOOODOOODODO

#00 0 0x00007ffff612d65all in( __GI__10_default_xsputn (f=0x7fffedffd600,00 data=0x7ffff7221ef7,00 n=0)
000 0O atd genops.c:447

#10 0 0x00007ffff60fbdcOl] inC _10_vfprintf_internall (s=s@entry=0x7fffedffd600,0]

00 0O O format=format@entry=0x7ffff7221ef70 "%lu",0 ap=ap@entry=0x7fffedffd738)0 at vfprintf.c:1340
#2[0 0 0x00007ffff61bb0f40 in0 __ vsprintf_chkO (s=0x7fffdc010fe50 ",0 flags=1,00 slen=18446744073709551615,0
00 0 O format=0x7ffff7221ef70 "%lu",0 args=args@entry=0x7fffedffd738)0 at[] vsprintf_chk.c.84

#30 0 0x00007ffff61bb04d0 in0 ___sprintf_chkO (s=<optimizedO out>,0] flags=<optimizedd out>,0]

0 O O O slen=<optimized out>,] format=<optimizedd out>)0 at0 sprintf_chk.c:31

#4[ [0 0x00007ffff718c69b0] in0 pp_key(omniORB::logger&,[] unsigned char( const*,[] int)0 ()

0 0 O fromO /usr/local/lib/libomniORB4.50.2

#50 0 0x00007ffff718c7540 in0 omniORB::logger::operator<<(omnilLocalldentityd const*)O ()

0 0 O from0O /usr/local/lib/libomniORB4.s0.2

#60 0 0x00007ffff719237b0 in0 omniObjTable:newEntry(omniObjKey&,[1 unsigned int)[ ()

0 0 O fromO /usr/local/lib/libomniORB4.s0.2

#70 0 0x00007ffff71a8d090] in(l omni::omniOrbPOA::servant_to_id(PortableServer::ServantBase*)(] ()

0 0 O fromO /usr/local/lib/libomniORB4.50.2

#80 [ 0x00007ffff7aace9all in(l RTC::OutPortCorbaCdrProvider::"OutPortCorbaCdrProvider()O ()

#8 -2016/01/29 13:37 - n-ando
-000 0300040000

000 Odeactivate_ object) DO 0OO0O0OO0OOCOOOOOOOODODO
Provider( Factoryl coil::Destructorl) 00 0 0 O O O MyDestuctord 0 0 0 0 O

externd "C"O

{
0 O voidd MyDestructor(:RTC::OutPortProvider*&[ obj)
oo{

000 0ifd (objd ==0 0)T {0 return;C }

0 00O O :RTC::OutPortCorbaCdrProvider*0 tmpO =0 dynamic_cast<[ :RTC::OutPortCorbaCdrProvider*[] >(obj);
000000 (tmpUd ==0 0)J {U return;0 }

ooO0Otry

oooooof

00000000 PortableServer:Objectld_var(l oid;
00000000 std:coutd << "1"0 <<0O std::endl;
00000000 oidO =0 tmp->_default_POA()->servant_to_id(tmp);
00000000 std:coutd <<0 "2"0 << std:endl;
00000000 tmp->_default_POA()->deactivate_object(oid);
ooooood

000 OcatchO (...)

oooooof

00000000 std:coutd << "Exceptiond in0 deactivate_object()"d << std::endl;
oooooo}

0 0 0 O std::coutd << "3"0 <<0 std::endl;

00 0O O delete obj;

000 O std:coutd <<0 "4"0 << std:endl;

0000objo=00;

00 0 O std::coutd << "5"0 <<0O std::endl;

oo}

oo/

Oo00*0 @ifOjp

OoO0*OebriefCOOODOOOOODOO

000*0 @else

00 0 *0 @briefd Modulel initialization

000 *0 @endif

ooo*/

0 O voidd OutPortCorbaCdrProviderlnit(void)

oo{

0 0 0O O RTC:OutPortProviderFactory&

000 00 0O factory(RTC::OutPortProviderFactory::instance());

0 0 O O factory.addFactory(“corba_cdr",
00000000000000000000000 :coil:Creator<d ::RTC::OutPortProvider,

0000000000000 000000000000000000000000000:RTC::OutPortCorbaCdrProvider>,

00000D000000000000000000MyDestructor);
oo}

oooooooo
ServantActivator0 0 0 000 000000000000

#9 - 2016/02/03 22:35 - n-ando

CORBA Objectt) 0 0 00 00O 0O O O deactivate servantO delete0 0 O O 0O 0O
SServantO OO Odelete0 D0 00000 O0OOOODOODOODO
-O0000OreadDataPort0 DO OO O OOQOOOOO

® connect
* notify_connect

* get

® disconnect

¢ deactivate_servant
* delete

ooooooo
00000O00getOdtorDO00O0ODOOODODOODOOODOOODOODOODODOODOO

0 O OutPortCorbaCdrProvider::OutPortCorbaCdrProvider(void)
00 O:0 m_buffer(0)

oof{

0 0 O O Guardd guard(m_mutex);

O

0 O OutPortCorbaCdrProvider:~OutPortCorbaCdrProvider(void)
oo{

0 0 0O O Guardd guard(m_mutex);

00000000 std:coutd <<0 "1"0 << std:endl;
OOoOOtry

oooooofq

O

0 O ::OpenRTM::PortStatus

0 O OutPortCorbaCdrProvider:get(:0OpenRTM::CdrData_out[] data)
00 0O O throwd (CORBA::SystemException)
oo{
0 0 0O O Guardd guard(m_mutex);
00 0O ORTC_PARANOID(("OutPortCorbaCdrProvider:get()");

00000000000000 -00Qactivation_foundDOOOOODOODODOO
0 0O O deactivate_object 0 0 0O O O O O omniORB: WARNING -- method 'get' raised an unexpected D 0000000

~WN PR

omniORB:0 State[d root<223>0 (active) ->[ deactivating

omniORB:[ Object[ isO stillO busy( --0 etherealise[] later.

5

omniORB:0 ObjRef(IDL:OpenRTM/OutPortCdr:1.0)0 --0 deleted.

omniORB:00 ERRORO --0 A servant0 has[ been deleted( thatO isO stillC) activated.
00 0000id:0 root<223>0 (deactivating)

omniORB:0 POA(RootPOA)[ etherealising[] object[] root<223>[1 (deactivating).
Oid:

omniORB:0 Assertion(] failed.OJ [0 ThisO indicatesO all bugd in( the application
usingd omniORB,0 ord maybe in(0 omniORBO itself.

Ofile:d ../../../../../src/lib/omniORB/orbcore/omniServant.cc

O line:0 223

0 info:0 activation_found

omniORB:[0 WARNINGO --00 method0 'get'0 raised(] an[] unexpected

O exceptiond (not ald CORBAL exception).

omniORB:0 sendChunk:[ to giop:tcp:[::ffff:10.211.55.4]:447030 680 bytes
omniORB:

#10 - 2016/05/13 10:14 - n-ando
-000 04000 90000

CORBAU O OOOODODDOOOODDOOOODDOOOODODOOODODOO
O0O0OrmpyD 0 0000000000000 0OOOOOOOOPortProfileproperties
o0o0o0ooo0o0ooOo0oooOo0oooOoooooOoUooOoOobDoOo

OutPorthO OO

-0 OutPorth0 0 O0(D 0 O0O0O0O2718)

+++0 OutPorthO OO (OO DODOO)

@@0 -138,600 +138,80 @@

O #endif

0000000034 m_value(value),d m_onWrite(0),0 m_onWriteConvert(0)

ooooof

+0 0 0 0 0 0O addProperty("dataport.data_value",(0 m_value);

+0 00 0 OO m_propValuelndexO =0 NVULil:find_index(m_profile.properties,d "dataport.data_value");
oooooy

gooogrsH

@@0 -209,60 +211,70 @@

00000000000 (*m_onWrite)(value);
0000000000 ORTC_TRACE(("OnWriteO called"));
oooooooood

+0 00 00O O m_profile.propertiesim_index].valuel] <<=[J value;

0000000 boold result(true);

0000000 std:vector<const char] *>[] disconnect_ids;
@@0 -490,600 +493,80] @@

000 O O coil: TimeMeasure[d m_cdrtime;

0 0 0O O O DataPortStatusList[] m_status;

+

+0 0 O O CORBA:Long m_propValuelndex;
oooy

0 }0//0 namespaced RTC

---0 rtm.py.orgd 0 2016-05-130 10:12:34.8920000000 +0900

+++0 rtm.py0 O O 0O O O 2016-05-130 10:12:57.00400000001 +0900
@@U0 -635,110 +635,1900 @@

O #0 \returnd data

O#

[ defl] readDataPort(port,[] timeout=1.0):

-0 00 O pprofd =00 port.get_port_profile()
+0000try:

+00000000 pprofd =0 port.get_port_profile()

+0 0O O O except:

+0 0000000 returnd None

+0 0 O O classnamel] =0 None

+0 0 O O datavaluel =00 None

0 0 00O ford propd in0O pprof.properties:

00000000 0IfD prop.namel == "dataport.data_type™:

000000000000 dclassnamel =0 any.from_any(prop.value)
000000000000 break

+00000000if0 prop.nameld == "dataport.data_value":

+0 00000000000 datavalued =0 any._to_tc_value(prop.value)[1]
+000000000000 returnd datavalue

+

00000 nvlO =0 SDOPackage.NameValue("dataport.interface_type",[0 any.to_any("corba_cdr"))
0 0 0 0 0 nv20 =0 SDOPackage.NameValue("dataport.dataflow_type",[J any.to_any("Pull"))
000 00O nv30 =0 SDOPackage.NameValue("dataport.subscription_type",[J any.to_any("flush"))
